/**
 *Clase que representa una baraja de cartas y contiene los métodos
 *necesarios para gestionarla.
 * @author montagon
 * @version 1.0
 */

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Random;

public class Baraja implements Serializable{
    
	private static final long serialVersionUID = 1L;
	private ArrayList<Carta> baraja = new ArrayList<Carta>();
    private int numero;
    Random r;
    /**
	 * Constructor de la clase.
	 */
    public Baraja() {
        r = new Random(System.currentTimeMillis());
        numero = 0;
    }
    /**
     * Método que añade una carta a la baraja
     * @param c carta a añadir
     * @return void
     */
    public void addCarta(Carta c){
        baraja.add(c);
        numero++;
    }
    /**
     * Método que elimina una carta de la baraja
     * @param c
     * @return void
     */
    public void removeCarta(Carta c){
        baraja.remove(c);
        numero--;
    }
    /**Método que devuelve una carta aleatoria de la baraja
     * @return carta a devolver
     */
    public Carta getCarta(){
        return baraja.get(r.nextInt(numero));
    }
}
