/**
 *Clase que representa una carta y contiene los métodos
 *necesarios para gestionarla.
 * @author montagon
 * @version 1.0
 */

import java.io.Serializable;

public class Carta implements Serializable{
    
	private static final long serialVersionUID = 1L;
	private String palo;
    private int numero;
    /**
     * Método constructor de la clase.
     * @param palo palo de la carta
     * @param numero numero de la carta
     */
    public Carta(String palo, int numero) {
        this.palo = palo;
        this.numero = numero;
    }
    /**
     * Método observador que devuelve el palo de la carta
     * @return String palo de la carta
     */
    public String getPalo() {
        return palo;
    }
    /**
     * Método que modifica el palo de la carta
     * @param palo nuevo palo de la carta
     * @return void
     */
    public void setPalo(String palo) {
        this.palo = palo;
    }
    /**
     * Método que devuelve el numero de una carta
     * @return int numero de la carta
     */
    public int getNumero() {
        return numero;
    }
    /**
     * Método que modifica el numero de la carta
     * @param numero nuevo numero de la carta
     * @return void
     */
    public void setNumero(int numero) {
        this.numero = numero;
    }
    /**
     * Método que devuelve la representación del objeto en una cadena.
     * @return String contenido de la clase en forma de cadena
     */
    @Override
    public String toString() {
        return " " + numero + " de " + palo;
    }
}
