
import java.io.Serializable;

/**
 * Clase usada para almacenar los datos de una partida y el servidor donde se aloja.
 * @author Alberto
 */
public class DatosServidorPartida implements Serializable {
	private static final long serialVersionUID = 1L;
	private String ip, nombre;
	private int numJugadores;
	private long id;
	
	public DatosServidorPartida(String ip, String nombre, int numJugadores) {
		this.ip = ip;
		this.nombre = nombre;
		this.numJugadores = numJugadores;
		this.id = -1;
	}
	
	public String getIp() {
		return ip;
	}
	
	public String getNombre() {
		return nombre;
	}
	
	public int getNumJugadores() {
		return numJugadores;
	}
	
	public void setId(long id) {
		this.id = id;
	}
	
	public long getId() {
		return id;
	}
	
	@Override
	public String toString() {
		return (id + " IP: " + ip + " " + nombre + " " + numJugadores + " jugadores");
	}
}
