import java.rmi.*;
import java.rmi.server.*;
import java.util.*;
public class ImpInterfazServidor extends UnicastRemoteObject implements InterfazServidor{
	private static final long serialVersionUID = 1L;
	private ArrayList<InterfazCliente> ListaClientes;
    private int numPlayers;
    private boolean numPlayersOn; //Para ver si ya se ha fijado el numPlayers
    /**
     * Constructor de la clase.
     * @throws RemoteException 
     */
    public ImpInterfazServidor() throws RemoteException{
        super();
        ListaClientes = new ArrayList<InterfazCliente>();
        numPlayersOn = false;
    }
    
    /**
     * Registra un cliente.
     * @param ObjetoCallBack
     * @throws RemoteException 
     */
    @Override
    public synchronized boolean RegistroCallBack(InterfazCliente ObjetoCallBack) throws RemoteException{
    	boolean b = true;
        if(ListaClientes.size() < numPlayers){
            if(!(ListaClientes.contains(ObjetoCallBack))){
                ListaClientes.add(ObjetoCallBack);
                System.out.println("Nuevo cliente de callback registrado...");
                EfectuarCallBack();
            }
            if(ListaClientes.size() == numPlayers){
                juego();
            }
        }else{
        	b = false;
        }
        return b;
    }
    
    private synchronized void juego(){
        System.out.println("Empieza el juego.");
        boolean finalizado = false;
        while(finalizado == false){
            //System.out.println("Empieza el juego.");
            finalizado = true;
        }
    }
    
    /**
     * Elimina un cliente de la lista.
     * @param ObjetoCallBack
     * @throws RemoteException 
     */
    @Override
    public synchronized void QuitarCallBack(InterfazCliente ObjetoCallBack) throws RemoteException{
        EfectuarCallBack();
        if(ListaClientes.remove(ObjetoCallBack)) {
            System.out.println("Cliente eliminado...");
        }
        else {
            System.out.println("Cliente no registrado...");
        }
        EfectuarCallBack();
    }
    
    /**
     * Código de llamada a los clientes.
     * Es de prueba. HAY QUE MODIFICARLO.
     * @throws RemoteException 
     */
    private synchronized void EfectuarCallBack()throws RemoteException{
        for(int i=0; i<ListaClientes.size(); i++)
        {
            InterfazCliente Cliente = (InterfazCliente)ListaClientes.get(i);
            Cliente.mensaje("Eres el cliente número: " + i);
        }//for
    }

    @Override
    public void sacarCarta() throws RemoteException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public ArrayList<Carta> verCartaCrupier() throws RemoteException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public void setNumPlayers(int n) throws RemoteException {
        if(numPlayersOn == false){
            numPlayers = n;
            numPlayersOn = true;
        }
    }
}